﻿// --------------------------------------------------------------------------------------
//
// DistanceEventCS                                                 Ulrich Müller 25.10.09
//                                                                 Aspire C# 2005 Express
// Programmrahmen (Template) für den Einsatz der Assembly FishFaceTX.DLL
// Achtung : Der COM-Name zu Anfang der Klasse muß angepasst werden.
//
// --------------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using FishFaceTX;

namespace DistanceEventCS {
  public partial class frmMain : Form {
    FishControl fc = new FishControl();
    DistanceSensor ultra;

    void ultra_CurrentValue(AnalogInput sender, int Value) {
      lblStatus.Text = ultra.ActualValue.ToString();
    }

    private void Action() {
      do {
        fc.Pause(444);
      } while (!fc.Finish());
    }

    #region --- Programm-Kontrolle ---
    public frmMain() {
      InitializeComponent();
      Label.CheckForIllegalCrossThreadCalls = false;
      ultra = new DistanceSensor(fc, true, Ctr.Main, Unv.I5);
      ultra.CurrentValue += new AnalogInput.Limit(ultra_CurrentValue);
    }

    private void cmdAction_Click(object sender, EventArgs e) {
      try {
        fc.Connect(txtCom.Text);
        fc.StartEvents();
        cmdAction.Enabled = false;
        cmdEnde.Text = "&HALT";
        lblStatus.Text = "--- Bei der Arbeit ---";
        lblHinweis.Text = "--- Ende : HALT-Button oder ESC-Taste ---";

        Action();        // --- Haupt-Routine der Anwendung

      }
      catch (FishFaceException txe) {
        MessageBox.Show(txe.Message, this.Text,
          MessageBoxButtons.OK, MessageBoxIcon.Stop);
      }
      finally {
        fc.DisConnect();
        cmdAction.Enabled = true;
        cmdEnde.Text = "&ENDE";
        lblStatus.Text = "--- Auf ein Neues ---";
        lblHinweis.Text = "Nochmal : ACTION, sonst ENDE oder ESC-Taste";
        cmdAction.Focus();
      }
    }

    private void cmdEnde_Click(object sender, EventArgs e) {
      if (cmdEnde.Text == "&HALT") fc.NotHalt = true; else this.Close();
    }

    private void formClosing(object sender, FormClosingEventArgs e) {
      if (cmdEnde.Text == "&HALT") e.Cancel = true;
    }
    #endregion
  }
}