﻿// --------------------------------------------------------------------------------------
//
// Motor.CS                                                     Ulrich Müller 01.11.09
//                                                              Aspire C# 2005 Express
// Betrieb eines Motors an M1...M4
//
// --------------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Text;

namespace FishFaceTX {
  public class Motor : DualOutput {
    uint sZeit;
    int mSek;

    public Motor(FishControl fc, Ctr ctrId, Mot MotName) 
      : this(fc, false, ctrId, MotName) {
    }
    public Motor(FishControl fc, bool WithEvents, Ctr ctrId, Mot MotName)
      : base(fc, ctrId, MotName) {
    }

    public void StartForward(int speed, int mSek) {
      sZeit = FishFace.GetTickCount();
      this.mSek = mSek;
      this.Left(speed);
    }
    public void Forward() {
      base.Left();
    }
    public void Forward(int speed) {
      base.Left(speed);
    }
    public void ForwardTime(int mSek) {
      ForwardTime(512, mSek);
    }
    public void ForwardTime(int speed, int mSek) {
      ForwardTime(speed, mSek, null);
    }
    public void ForwardTime(int speed, int mSek, D5KInput TermInput) {
      StartForward(speed, mSek);
      WaitForDone(TermInput);
    }

    public void StartBackward(int speed, int mSek) {
      sZeit = FishFace.GetTickCount();
      this.mSek = mSek;
      this.Right(speed);
    }
    public void Backward() {
      base.Right();
    }
    public void Backward(int speed) {
      base.Right(speed);
    }
    public void BackwardTime(int mSek) {
      BackwardTime(512, mSek);
    }
    public void BackwardTime(int speed, int mSek) {
      BackwardTime(speed, mSek, null);
    }
    public void BackwardTime(int speed, int mSek, D5KInput TermInput) {
      StartBackward(speed, mSek);
      WaitForDone(TermInput);
    }

    public void StartUp(int speed, int mSek) {
      StartForward(speed, mSek);
    }
    public void Up() {
      base.Left();
    }
    public void Up(int speed) {
      base.Left(speed);
    }
    public void UpTime(int mSek) {
      UpTime(512, mSek);
    }
    public void UpTime(int speed, int mSek) {
      ForwardTime(speed, mSek);
    }
    public void UpTime(int speed, int mSek, D5KInput TermInput) {
      ForwardTime(speed, mSek, TermInput);
    }

    public void StartDown(int speed, int mSek) {
      StartBackward(speed, mSek);
    }
    public void Down() {
      base.Right();
    }
    public void Down(int speed) {
      base.Right(speed);
    }
    public void DownTime(int mSek) {
      DownTime(512, mSek);
    }
    public void DownTime(int speed, int mSek) {
      BackwardTime(speed, mSek);
    }
    public void DownTime(int speed, int mSek, D5KInput TermInput) {
      BackwardTime(speed, mSek, TermInput);
    }

    public virtual void WaitForDone() {
      WaitForDone(null);
    }
    public void WaitForDone(D5KInput TermInput) {
      while (FishFace.GetTickCount() - sZeit < mSek && !tx.NotHalt && !tx.IsESC) {
        if (TermInput != null) if (TermInput.IsTrue) {
            this.Off(); return;
          }
        tx.Pause(12);
      }
      this.Off();
    }
  }
}
